## lomiri-printing-app 0.4.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15)
project(lomiri-printing-app VERSION 0.4.1 LANGUAGES CXX)


# Always Be Testing
enable_testing()

# Load translation tools
find_package(Intltool REQUIRED)

# Set the vars
set(CMAKE_AUTOMOC ON)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++14")  # -fno-permissive -pedantic -Wall -Wextra")

# Set the options
option(SNAP_MODE "Build as a snap package" off)
option(CLICK_MODE "Build as a click package" off)

include(CTest)

find_package(PkgConfig REQUIRED)

pkg_check_modules(POPPLER-QT REQUIRED poppler-qt5)

if (BUILD_TESTING)
  find_program(XVFBRUN xvfb-run REQUIRED)
  set(XVFB_COMMAND ${XVFBRUN} -s "-screen 0 640x480x24" -a)

  find_program(QMLTESTRUNNER qmltestrunner REQUIRED)
endif()

# Find packages
list(APPEND QT_COMPONENTS
  Core
  Gui
  PrintSupport
  Qml
  Quick
)

if(BUILD_TESTING)
  list(APPEND QT_COMPONENTS
    QuickTest
    Test
  )
endif()

find_package(Qt5 COMPONENTS ${QT_COMPONENTS} REQUIRED)

include(GNUInstallDirs)

if(DEFINED QT_IMPORTS_DIR)
  message(STATUS "QT_INSTALL_QML set, installing QML modules to ${QT_INSTALL_QML}")
else()
  if(CLICK_MODE)
    execute_process(
      COMMAND dpkg-architecture -qDEB_HOST_MULTIARCH
      OUTPUT_VARIABLE ARCH_TRIPLET
      OUTPUT_STRIP_TRAILING_WHITESPACE
    )
    set(QT_IMPORTS_DIR "lib/${ARCH_TRIPLET}")
  else()
    get_target_property(QMAKE_EXECUTABLE Qt5::qmake LOCATION)
    execute_process(
      COMMAND ${QMAKE_EXECUTABLE} -query QT_INSTALL_QML
      OUTPUT_VARIABLE QT_IMPORTS_DIR
      OUTPUT_STRIP_TRAILING_WHITESPACE
    )
  endif()
endif()

# Setup gettext defs
set(GETTEXT_PACKAGE "lomiri-printing-app")

# Add subdirs
#add_subdirectory(notifier)
add_subdirectory(lomiri-printing-app)

# Add queue dialog
add_subdirectory(queue-dialog)

# Add translations
add_subdirectory(po)

# Show files in QtC
file(GLOB QTC_FILES
     RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}
     *.cpp *.js .qml README*)

# This figures out the target architecture for use in the manifest file.
if(DEFINED ENV{ARCH})
    set(CLICK_ARCH "$ENV{ARCH}")
else()
    execute_process(
        COMMAND dpkg-architecture -qDEB_HOST_ARCH
        OUTPUT_VARIABLE CLICK_ARCH
        OUTPUT_STRIP_TRAILING_WHITESPACE
    )
endif()

if(CLICK_MODE)
  configure_file(manifest.json.in ${CMAKE_CURRENT_BINARY_DIR}/manifest.json)
  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/manifest.json DESTINATION "${CMAKE_INSTALL_PREFIX}")
  install(FILES apparmor.json DESTINATION "${CMAKE_INSTALL_PREFIX}")
  install(FILES apparmor-queue.json DESTINATION "${CMAKE_INSTALL_PREFIX}")
endif()

add_custom_target(lomiri_printing_app_qtc_files DEPENDS Main.qml SOURCES ${QTC_FILES})

=== lomiri-printing-app/CMakeLists.txt ===
set(APP_NAME lomiri-printing-app)
set(APP_HARDCODE lomiri-printing-app)
set(DESKTOP_FILE "${APP_NAME}.desktop")
set(MAIN_QML Main.qml)
set(ICON_FILE lomiri-printing-app.svg)
set(SNAP_DESKTOP_FILE snap/gui/${DESKTOP_FILE})

# Set the path for the QML files and the backend
set(DATA_DIR "${CMAKE_INSTALL_FULL_DATADIR}/${APP_HARDCODE}")

configure_file (${CMAKE_SOURCE_DIR}/config.hpp.in ${CMAKE_CURRENT_BINARY_DIR}/config.hpp @ONLY)

add_executable (${APP_HARDCODE}
  ${CMAKE_SOURCE_DIR}/main.cpp
  ${CMAKE_CURRENT_BINARY_DIR}/config.hpp
)

target_include_directories (${APP_HARDCODE}
  PRIVATE
  ${CMAKE_CURRENT_BINARY_DIR}
)

target_link_libraries (${APP_HARDCODE}
  PUBLIC
  Qt5::Core
  Qt5::Gui
  Qt5::Qml
  Qt5::Quick
)

set (EXEC_DESTINATION "${CMAKE_INSTALL_BINDIR}")
if (CLICK_MODE)
  set (EXEC_DESTINATION "${CMAKE_INSTALL_PREFIX}")
endif()

# Icon path
set(ICON_DESTINATION "${DATA_DIR}")
if(CLICK_MODE)
  set(ICON_DESTINATION "${CMAKE_INSTALL_PREFIX}")
endif()

# Set the desktop file variables
set(EXEC "env APP_ID=${APP_HARDCODE} ${APP_HARDCODE}")
set(ICON "${ICON_DESTINATION}/${ICON_FILE}")
if (SNAP_MODE)
  set(ICON "$SNAP/${ICON}")
elseif (CLICK_MODE)
  set(ICON "${ICON_FILE}")
endif()

add_subdirectory(backend)
add_subdirectory(components)
add_subdirectory(pages)

# Add tests
if (BUILD_TESTING)
    add_subdirectory(tests)
endif()

install(TARGETS ${APP_HARDCODE} RUNTIME DESTINATION ${EXEC_DESTINATION})

# Install Main.qml and icon
install(FILES ${MAIN_QML} DESTINATION ${DATA_DIR})
install(FILES ${ICON_FILE} DESTINATION ${ICON_DESTINATION})

# Install content-hub json
install(FILES "lomiri-printing-app-content-hub.json"
    DESTINATION ${CMAKE_INSTALL_FULL_DATADIR}/lomiri-content-hub/peers
    RENAME ${APP_HARDCODE})

# Install desktop file
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/${DESKTOP_FILE}.in.in ${CMAKE_CURRENT_BINARY_DIR}/${DESKTOP_FILE}.in)
intltool_merge_translations(
  "${CMAKE_CURRENT_BINARY_DIR}/${DESKTOP_FILE}.in"
  "${CMAKE_CURRENT_BINARY_DIR}/${DESKTOP_FILE}"
  ALL 
  UTF8
)

# Install content-hub json & desktop file
if(CLICK_MODE)
  install(FILES "lomiri-printing-app-content-hub.json"
      DESTINATION ${CMAKE_INSTALL_PREFIX})
  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${DESKTOP_FILE}
      DESTINATION ${CMAKE_INSTALL_PREFIX})
else()
  install(FILES "lomiri-printing-app-content-hub.json"
      DESTINATION ${CMAKE_INSTALL_FULL_DATADIR}/lomiri-content-hub/peers
      RENAME ${APP_HARDCODE})
  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${DESKTOP_FILE} 
      DESTINATION ${CMAKE_INSTALL_DATADIR}/applications)
endif()

# Show in QtCreator
if(NOT "${CMAKE_CURRENT_SOURCE_DIR}" STREQUAL "${CMAKE_CURRENT_BINARY_DIR}")
  file(GLOB MAIN_QML_JS_FILES *.apparmor *.js *.json *.qml)
  add_custom_target(lomiri_printing_app_main_qml_js_files ALL SOURCES ${MAIN_QML_JS_FILES})
endif(NOT "${CMAKE_CURRENT_SOURCE_DIR}" STREQUAL "${CMAKE_CURRENT_BINARY_DIR}")

# Set variables for use in parent scope
set(LOMIRI_PRINTING_APP_DESKTOP_FILE "${DESKTOP_FILE}" PARENT_SCOPE)

=== po/CMakeLists.txt ===
intltool_update_potfile(
    KEYWORDS "_" "_:1,2" "N_" "N_:1,2" "tr" "tr:1,2"
    GETTEXT_PACKAGE ${GETTEXT_PACKAGE}
    COPYRIGHT_HOLDER "Canonical Ltd."
    FILE_GLOBS "${CMAKE_SOURCE_DIR}/*.desktop.in.in" "${CMAKE_SOURCE_DIR}/*.qml"
    FILTER "tests/*"
)

intltool_install_translations(
    ALL
    GETTEXT_PACKAGE ${GETTEXT_PACKAGE}
)

=== queue-dialog/CMakeLists.txt ===
set(APP_HARDCODE lomiri-printqueue-dialog)
set(APP_NAME lomiri-printqueue-dialog)
set(DESKTOP_FILE "${APP_NAME}.desktop")
set(MAIN_QML Main.qml)
set(ICON_FILE ${APP_NAME}.svg)
set(SNAP_DESKTOP_FILE snap/gui/${DESKTOP_FILE})

# Set the path for the QML files and the backend
set(DATA_DIR "${CMAKE_INSTALL_FULL_DATADIR}/lomiri-printing-app/queue-dialog")

configure_file (${CMAKE_SOURCE_DIR}/config.hpp.in ${CMAKE_CURRENT_BINARY_DIR}/config.hpp @ONLY)

add_executable (${APP_HARDCODE}
  ${CMAKE_SOURCE_DIR}/main.cpp
  ${CMAKE_CURRENT_BINARY_DIR}/config.hpp
)

target_include_directories (${APP_HARDCODE}
  PRIVATE
  ${CMAKE_CURRENT_BINARY_DIR}
)

target_link_libraries (${APP_HARDCODE}
  PUBLIC
  Qt5::Core
  Qt5::Gui
  Qt5::Qml
  Qt5::Quick
)

set (EXEC_DESTINATION "${CMAKE_INSTALL_BINDIR}")
if (CLICK_MODE)
  set (EXEC_DESTINATION "${CMAKE_INSTALL_PREFIX}")
endif()

# Icon path
set(ICON_DESTINATION "${DATA_DIR}")
if(CLICK_MODE)
  set(ICON_DESTINATION "${CMAKE_INSTALL_PREFIX}")
endif()

# Set the desktop file variables
set(EXEC "env APP_ID=${APP_HARDCODE} ${APP_HARDCODE}")
set(ICON "${ICON_DESTINATION}/${ICON_FILE}")
if (SNAP_MODE)
  set(ICON "$SNAP/${ICON}")
elseif (CLICK_MODE)
  set(ICON "${ICON_FILE}")
endif()

add_subdirectory(components)
add_subdirectory(pages)

# Add tests
if (BUILD_TESTING)
  add_subdirectory(tests)
endif()

install(TARGETS ${APP_HARDCODE} RUNTIME DESTINATION ${EXEC_DESTINATION})

# Install Main.qml and icon
install(FILES ${MAIN_QML} DESTINATION ${DATA_DIR})
install(FILES ${ICON_FILE} DESTINATION ${ICON_DESTINATION})

# Install desktop file
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/${DESKTOP_FILE}.in.in ${CMAKE_CURRENT_BINARY_DIR}/${DESKTOP_FILE}.in)
intltool_merge_translations(
  "${CMAKE_CURRENT_BINARY_DIR}/${DESKTOP_FILE}.in"
  "${CMAKE_CURRENT_BINARY_DIR}/${DESKTOP_FILE}"
  ALL
  UTF8
)

if(CLICK_MODE)
  set(DESKTOP_LOCATION "${CMAKE_INSTALL_PREFIX}")
else(CLICK_MODE)
  set(DESKTOP_LOCATION "${CMAKE_INSTALL_DATADIR}/applications")
endif()

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${DESKTOP_FILE}
        DESTINATION ${DESKTOP_LOCATION})

# Install the url dispatcher
# For now any printing:/// uri will open the queue dialog
if(CLICK_MODE)
  install(FILES ${APP_NAME}.url-dispatcher DESTINATION ${CMAKE_INSTALL_PREFIX})
else(CLICK_MODE)
  install(FILES ${APP_NAME}.url-dispatcher DESTINATION ${CMAKE_INSTALL_DATADIR}/lomiri-url-dispatcher/urls)
endif()

# Show in QtCreator
if(NOT "${CMAKE_CURRENT_SOURCE_DIR}" STREQUAL "${CMAKE_CURRENT_BINARY_DIR}")
  file(GLOB QUEUE_MAIN_QML_JS_FILES *.apparmor *.js *.json *.qml)
  add_custom_target(lomiri_queue_dialog_main_qml_js_files ALL SOURCES ${QUEUE_MAIN_QML_JS_FILES})
endif(NOT "${CMAKE_CURRENT_SOURCE_DIR}" STREQUAL "${CMAKE_CURRENT_BINARY_DIR}")

# Set variables for use in parent scope
set(LOMIRI_QUEUE_DIALOG_DESKTOP_FILE "${DESKTOP_FILE}" PARENT_SCOPE)

=== lomiri-printing-app/components/CMakeLists.txt ===
set(COMPONENT_QML_JS_FILES
    AlertDialog.qml
    BaseRowLayout.qml
    CheckBoxRow.qml
    LabelRow.qml
    PreviewRow.qml
    PrintRow.qml
    PrintingHelper.qml
    SelectorRow.qml
    TextFieldRow.qml
)

install(FILES ${COMPONENT_QML_JS_FILES} DESTINATION ${DATA_DIR}/components)

# Show in QtCreator
add_custom_target(lomiri_printing_app_components_qml_js_files ALL SOURCES ${COMPONENT_QML_JS_FILES})

=== notifier/data/CMakeLists.txt ===
##
##  Systemd Unit File
##

# where to install
set (SYSTEMD_USER_DIR "${CMAKE_INSTALL_LIBDIR}/systemd/user")
message (STATUS "${SYSTEMD_USER_DIR} is the systemd user unit file install dir")

set (SYSTEMD_USER_NAME "${SERVICE_LIB_NAME}.service")
set (SYSTEMD_USER_FILE "${CMAKE_CURRENT_BINARY_DIR}/${SYSTEMD_USER_NAME}")
set (SYSTEMD_USER_FILE_IN "${CMAKE_CURRENT_SOURCE_DIR}/${SYSTEMD_USER_NAME}.in")

# build it
set (pkglibexecdir "${CMAKE_INSTALL_FULL_PKGLIBEXECDIR}")
configure_file ("${SYSTEMD_USER_FILE_IN}" "${SYSTEMD_USER_FILE}")

# install it
install (FILES "${SYSTEMD_USER_FILE}"
         DESTINATION "${SYSTEMD_USER_DIR}")

##
##  Upstart systemd override Job File
##

set (UPSTART_SYSTEMD_OVERRIDE_DIR "${CMAKE_INSTALL_FULL_DATADIR}/upstart/systemd-session/upstart")
message (STATUS "${UPSTART_SYSTEMD_OVERRIDE_DIR} is the Upstart override Job File for systemd dir")

install (FILES "${CMAKE_CURRENT_SOURCE_DIR}/${SERVICE_LIB_NAME}.override"
         DESTINATION "${UPSTART_SYSTEMD_OVERRIDE_DIR}")

##
##  Upstart Job File
##

# where to install
set (UPSTART_JOB_DIR "${CMAKE_INSTALL_FULL_DATADIR}/upstart/sessions")
message (STATUS "${UPSTART_JOB_DIR} is the Upstart Job File install dir")

set (UPSTART_JOB_NAME "${SERVICE_LIB_NAME}.conf")
set (UPSTART_JOB_FILE "${CMAKE_CURRENT_BINARY_DIR}/${UPSTART_JOB_NAME}")
set (UPSTART_JOB_FILE_IN "${CMAKE_CURRENT_SOURCE_DIR}/${UPSTART_JOB_NAME}.in")

# build it
configure_file ("${UPSTART_JOB_FILE_IN}" "${UPSTART_JOB_FILE}")

# install it
install (FILES "${UPSTART_JOB_FILE}"
         DESTINATION "${UPSTART_JOB_DIR}")

=== notifier/src/CMakeLists.txt ===
add_definitions(
  -DGETTEXT_PACKAGE=\"${PROJECT_NAME}\"
  -DGETTEXT_LOCALEDIR=\"${CMAKE_INSTALL_FULL_LOCALEDIR}\"
  -DG_LOG_DOMAIN=\"${CMAKE_PROJECT_NAME}\"
)

include_directories(
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${CMAKE_CURRENT_BINARY_DIR}
  ${SERVICE_DEPS_INCLUDE_DIRS}
)
link_directories(
  ${SERVICE_DEPS_LIBRARY_DIRS}
)

find_package(GDbus REQUIRED)
add_gdbus_codegen(
  SERVICE_GENERATED_SOURCES
  cups-cupsd-notifier
  org.cups.cupsd
  ${CMAKE_CURRENT_SOURCE_DIR}/org.cups.cupsd.Notifier.xml)

add_library(${SERVICE_LIB_NAME} STATIC
  actions.cpp
  actions.h
  client.h
  cups-client.cpp
  cups-client.h
  job.h
  notification.cpp
  notification.h
  notify-engine.cpp
  notify-engine.h
  printer.h
  utils.cpp
  utils.h
  ${SERVICE_GENERATED_SOURCES}
)

target_link_libraries(${SERVICE_LIB_NAME}
  ${SERVICE_DEPS_LIBRARIES}
  ${CUPS_LIBS}
)


add_executable(${SERVICE_EXEC_NAME}
  main.cpp
)

target_link_libraries(${SERVICE_EXEC_NAME}
  ${SERVICE_LIB_NAME}
  ${SERVICE_DEPS_LIBRARIES}
  ${CUPS_LIBS}

  ${CMAKE_THREAD_LIBS_INIT}
)

install(
  TARGETS ${SERVICE_EXEC_NAME}
  RUNTIME
  DESTINATION ${CMAKE_INSTALL_FULL_LIBDIR}/${PROJECT_NAME}
)

=== notifier/tests/CMakeLists.txt ===
find_package(GMock REQUIRED)

include_directories(
  ${CMAKE_SOURCE_DIR}/notifier/src
  ${SERVICE_DEPS_INCLUDE_DIRS}
)
link_directories(
  ${SERVICE_DEPS_LIBRARY_DIRS}
)

add_executable(test-${SERVICE_LIB_NAME}
  actions-mock.h
  client-mock.h
  mock-notification.h
  test_notify-engine.cpp
  test_utils.cpp
)
target_link_libraries(test-${SERVICE_LIB_NAME}
  ${SERVICE_LIB_NAME}
  ${SERVICE_DEPS_LIBRARIES}
  ${CUPS_LIBS}

  ${GTEST_LIBRARIES}
  ${GMOCK_LIBRARIES}

  ${CMAKE_THREAD_LIBS_INIT}
)
add_test(test-${SERVICE_LIB_NAME} test-${SERVICE_LIB_NAME})

=== queue-dialog/components/CMakeLists.txt ===
set(QUEUE_COMPONENTS_QML_JS_FILES
    QueueDelegate.qml
    QueueHelper.qml
    QueueView.qml
)

install(FILES ${QUEUE_COMPONENTS_QML_JS_FILES} DESTINATION ${DATA_DIR}/components)

# Show in QtCreator
add_custom_target(queue_components_qml_js_files ALL SOURCES ${QUEUE_COMPONENTS_QML_JS_FILES})

=== queue-dialog/pages/CMakeLists.txt ===
set(QUEUE_PAGES_QML_JS_FILES
    QueuePage.qml
)

install(FILES ${QUEUE_PAGES_QML_JS_FILES} DESTINATION ${DATA_DIR}/pages)

# Show in QtCreator
add_custom_target(queue_pages_qml_js_files ALL SOURCES ${QUEUE_PAGES_QML_JS_FILES})

=== queue-dialog/tests/CMakeLists.txt ===
add_subdirectory(qmltests)

=== lomiri-printing-app/tests/resources/CMakeLists.txt ===
add_subdirectory(pdf)

# Copy the test pdf files to the build dir
add_custom_target(test_pdf_copyFiles ALL
  COMMAND ${CMAKE_COMMAND} -E copy_directory ${CMAKE_CURRENT_SOURCE_DIR}/pdf ${CMAKE_CURRENT_BINARY_DIR}/pdf
  DEPENDS ${PDF_TEST_FILES})

=== debian/changelog ===
lomiri-printing-app (0.4.1-2) unstable; urgency=medium

  * Re-upload source-only as is.

 -- Mike Gabriel <sunweaver@debian.org>  Sat, 18 Jan 2025 17:56:28 +0100

lomiri-printing-app (0.4.1-1) unstable; urgency=medium

  * Initial upload to Debian. (Closes: #1092942).

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 13 Jan 2025 18:38:41 +0100

=== debian/control ===
Source: lomiri-printing-app
Section: misc
Priority: optional
Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
Uploaders: Mike Gabriel <sunweaver@debian.org>,
Build-Depends: cmake (>= 3.15),
               cmake-extras (>= 1.3),
               debhelper-compat (= 13),
               dh-apparmor,
               gcovr,
               googletest | google-mock,
               intltool,
               lcov,
               libboost-dev,
               libcups2-dev,
               libglib2.0-dev (>= 2.35.4),
               libnotify-dev,
               libpoppler-qt5-dev,
               libproperties-cpp-dev,
               liblomiri-url-dispatcher-dev,
               qml-module-qtquick2,
               qml-module-qtquick-layouts,
               qml-module-qttest,
               qml-module-lomiri-components (>= 1.3),
               qml-module-lomiri-components-extras,
               qml-module-lomiri-test,
               qml-module-lomiri-content,
               qtdeclarative5-dev,
               qtdeclarative5-dev-tools,
               xauth,
               xvfb,
Standards-Version: 4.7.0
Rules-Requires-Root: no
Homepage: https://gitlab.com/ubports/development/apps/lomiri-printing-app/
Vcs-Git: https://salsa.debian.org/ubports-team/lomiri-printing-app.git
Vcs-Browser: https://salsa.debian.org/ubports-team/lomiri-printing-app/

Package: lomiri-printing-app
Architecture: any
Depends: qml-module-qtquick2,
         qml-module-qtquick-layouts,
         qml-module-lomiri-components (>= 1.3),
         qml-module-lomiri-content,
         ${misc:Depends},
         ${shlibs:Depends},
Description: Printing app which consumes a PDF from content hub
 This app is an add-on app for Ubuntu Touch's shell Lomiri. Ubuntu Touch
 is a mobile OS developed by the UBports Foundation. Lomiri is its
 operating environment optimized for touch based human-machine
 interaction, but also supports convergence (i.e. switching between
 tablet/phone and desktop mode).
 .
 This package provides Lomiri's Printing App. The printing app consumes a
 PDF document from Lomiri's content-hub, allows for basic configuration
 and then sends the to-be-printed document to a CUPS print queue.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

%:
	dh $@

override_dh_install:
	dh_install
	dh_apparmor -plomiri-printing-app --profile-name=usr.bin.lomiri-printing-app

override_dh_missing:
	dh_missing --fail-missing

get-orig-source:
	uscan --noconf --force-download --rename --download-current-version --destdir=..

## lomiri-printing-app 0.4.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.15)
-project(lomiri-printing-app VERSION 0.4.1 LANGUAGES CXX)
+project(lomiri-printing-app VERSION 0.4.2 LANGUAGES CXX)
 
 
 # Always Be Testing

=== lomiri-printing-app/CMakeLists.txt ===
--- 
+++ 
@@ -40,7 +40,7 @@
 endif()
 
 # Set the desktop file variables
-set(EXEC "env APP_ID=${APP_HARDCODE} ${APP_HARDCODE}")
+set(EXEC "${APP_HARDCODE}")
 set(ICON "${ICON_DESTINATION}/${ICON_FILE}")
 if (SNAP_MODE)
   set(ICON "$SNAP/${ICON}")

=== notifier/CMakeLists.txt ===
### Install path variables
include (GNUInstallDirs)
if (EXISTS "/etc/debian_version") # Workaround for libexecdir on debian
  set (CMAKE_INSTALL_LIBEXECDIR "${CMAKE_INSTALL_LIBDIR}")
  set (CMAKE_INSTALL_FULL_LIBEXECDIR "${CMAKE_INSTALL_FULL_LIBDIR}")
endif ()
set (CMAKE_INSTALL_PKGLIBEXECDIR "${CMAKE_INSTALL_LIBEXECDIR}/${CMAKE_PROJECT_NAME}")
set (CMAKE_INSTALL_FULL_PKGLIBEXECDIR "${CMAKE_INSTALL_FULL_LIBEXECDIR}/${CMAKE_PROJECT_NAME}")

### Set variables for our binary build targets
set(SERVICE_LIB_NAME "printing-notifier")
set(SERVICE_EXEC_NAME "printing-notifier-service")

### Some default compile flags
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -O2 -g -fPIC")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -O2 -g -Wextra -Wall -Werror -Werror=conversion-null -Wno-ignored-qualifiers -fPIC")

### Find deps
find_package(PkgConfig REQUIRED)
find_package(Threads)

pkg_check_modules(SERVICE_DEPS REQUIRED
  gio-unix-2.0>=2.36
  glib-2.0>=2.36
  libnotify>=0.7.6
  properties-cpp
  lomiri-url-dispatcher
)

### Find libcups
find_program(CUPS_CONFIG cups-config)
execute_process(COMMAND ${CUPS_CONFIG} --cflags OUTPUT_VARIABLE CUPS_CFLAGS OUTPUT_STRIP_TRAILING_WHITESPACE)
execute_process(COMMAND ${CUPS_CONFIG} --libs OUTPUT_VARIABLE CUPS_LIBS OUTPUT_STRIP_TRAILING_WHITESPACE)

### Add sub-directories
add_subdirectory(data)
add_subdirectory(src)
add_subdirectory(tests)

### Enable coverage reporting
find_package(CoverageReport)
ENABLE_COVERAGE_REPORT(
  TARGETS ${SERVICE_LIB_NAME} ${SERVICE_EXEC_NAME}
  TESTS test-${SERVICE_LIB_NAME}
  FILTER /usr/include ${CMAKE_BINARY_DIR}/*
)

=== queue-dialog/CMakeLists.txt ===
--- 
+++ 
@@ -40,7 +40,7 @@
 endif()
 
 # Set the desktop file variables
-set(EXEC "env APP_ID=${APP_HARDCODE} ${APP_HARDCODE}")
+set(EXEC "${APP_HARDCODE}")
 set(ICON "${ICON_DESTINATION}/${ICON_FILE}")
 if (SNAP_MODE)
   set(ICON "$SNAP/${ICON}")

=== lomiri-printing-app/backend/CMakeLists.txt ===
set(LIBNAME LomiriPrintingAppBackend)

set(
  LomiriPrintingAppSRC
  LomiriPrintingApp/backend.cpp
  LomiriPrintingApp/document.cpp
  LomiriPrintingApp/popplerimageprovider.cpp
  LomiriPrintingApp/pagehelper.cpp
)

add_library(${LIBNAME} SHARED ${LomiriPrintingAppSRC})

target_include_directories(${LIBNAME}
  PUBLIC
  ${POPPLER-QT_INCLUDE_DIRS}
)

target_link_libraries(${LIBNAME}
  PUBLIC
  ${POPPLER-QT_LIBRARIES}
  Qt5::Core
  Qt5::Gui
  Qt5::Qml
  Qt5::Quick
)

set_target_properties(${LIBNAME} PROPERTIES
  LIBRARY_OUTPUT_DIRECTORY LomiriPrintingApp
)

# Copy the qmldir file to the build dir
add_custom_target(LomiriPrintingApp_qmldir ALL
  COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/LomiriPrintingApp/qmldir ${CMAKE_CURRENT_BINARY_DIR}/LomiriPrintingApp
  DEPENDS ${QMLFILES})

# Install the plugin file
install(TARGETS ${LIBNAME} DESTINATION ${QT_IMPORTS_DIR}/LomiriPrintingApp)
install(FILES LomiriPrintingApp/qmldir DESTINATION ${QT_IMPORTS_DIR}/LomiriPrintingApp)

=== lomiri-printing-app/pages/CMakeLists.txt ===
set(PAGES_QML_JS_FILES
    ContentPeerPickerPage.qml
    EmptyPage.qml
    PrintPage.qml
)

install(FILES ${PAGES_QML_JS_FILES} DESTINATION ${DATA_DIR}/pages)

# Show in QtCreator
add_custom_target(lomiri_printing_app_pages_qml_js_files ALL SOURCES ${PAGES_QML_JS_FILES})

=== lomiri-printing-app/tests/CMakeLists.txt ===
add_subdirectory(resources)
add_subdirectory(qmltests)
add_subdirectory(unittests)

=== lomiri-printing-app/tests/qmltests/CMakeLists.txt ===
set(TEST tst_QmlTests)
add_test(${TEST} ${XVFB_COMMAND} ${QMLTESTRUNNER}
         -input ${CMAKE_CURRENT_SOURCE_DIR}
         -import ${CMAKE_BINARY_DIR}/lomiri-printing-app/backend)


# Add the qml test files to build dir
set(QMLTEST_FILES
    tst_CheckBoxRow.qml
    tst_LabelRow.qml
    tst_PreviewRow.qml
    tst_PrintRow.qml
    tst_PrintPage.qml
    tst_SelectorRow.qml
    tst_TextFieldRow.qml
)

add_custom_target(qmltest_copyFiles ALL
  COMMENT "Copying files: ${QMLTEST_FILES}")

foreach(FILENAME ${QMLTEST_FILES})
  add_custom_command(
    TARGET qmltest_copyFiles
    COMMAND ${CMAKE_COMMAND} -E copy "${CMAKE_CURRENT_SOURCE_DIR}/${FILENAME}" "${CMAKE_CURRENT_BINARY_DIR}/${FILENAME}"
    )
endforeach(FILENAME)

# Show in QtC
add_custom_target(qmltest_files ALL SOURCES ${QMLTEST_FILES})

=== queue-dialog/tests/qmltests/CMakeLists.txt ===
set(TEST tst_QueueDialogQmlTests)
add_test(${TEST} ${XVFB_COMMAND} ${QMLTESTRUNNER}
         -input ${CMAKE_CURRENT_SOURCE_DIR})


# Add the qml test files to build dir
set(QUEUE_QMLTEST_FILES
    tst_QueueDelegate.qml
    tst_QueuePage.qml
    tst_QueueView.qml
)

add_custom_target(queue_qmltest_copyFiles ALL
  COMMENT "Copying files: ${QUEUE_QMLTEST_FILES}")

foreach(FILENAME ${QUEUE_QMLTEST_FILES})
  add_custom_command(
    TARGET queue_qmltest_copyFiles
    COMMAND ${CMAKE_COMMAND} -E copy "${CMAKE_CURRENT_SOURCE_DIR}/${FILENAME}" "${CMAKE_CURRENT_BINARY_DIR}/${FILENAME}"
    )
endforeach(FILENAME)

# Show in QtC
add_custom_target(queue_qmltest_files ALL SOURCES ${QUEUE_QMLTEST_FILES})

=== lomiri-printing-app/tests/resources/pdf/CMakeLists.txt ===
# Show files in QtC
file(GLOB PDF_TEST_FILES *.pdf *.txt)
add_custom_target(test_pdf_files ALL SOURCES ${PDF_TEST_FILES})

=== lomiri-printing-app/tests/unittests/backend/CMakeLists.txt ===
add_executable(testDocument tst_document.cpp ${PDF_TEST_FILES})
target_include_directories(testDocument PRIVATE ${CMAKE_SOURCE_DIR}/lomiri-printing-app/backend)
target_link_libraries(testDocument LomiriPrintingAppBackend Qt5::Test Qt5::Gui)
add_test(tst_document testDocument)

add_executable(testPageHelper tst_pagehelper.cpp ${PDF_TEST_FILES})
target_include_directories(testPageHelper PRIVATE ${CMAKE_SOURCE_DIR}/lomiri-printing-app/backend)
target_link_libraries(testPageHelper LomiriPrintingAppBackend Qt5::Test Qt5::Gui)
add_test(tst_pagehelper testPageHelper)

add_executable(testPopplerImageProvider tst_popplerimageprovider.cpp ${PDF_TEST_FILES})
target_include_directories(testPopplerImageProvider PRIVATE ${CMAKE_SOURCE_DIR}/lomiri-printing-app/backend)
target_link_libraries(testPopplerImageProvider LomiriPrintingAppBackend Qt5::Test Qt5::Gui)
add_test(tst_popplerimageprovider testPopplerImageProvider)

=== debian/changelog ===
lomiri-printing-app (0.4.2-1) unstable; urgency=medium

  * New upstream release.
  * debian/control:
    + Bump Standards-Version: to 4.7.2. No changes needed.
  * debian/patches:
    + Drop 1001_fix-desktop-files.patch. Applied upstream.
    + Add 2002_hide-app-if-not-in-lomiri.patch.
  * debian/copyright:
    + Update copyright attributions.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 05 May 2025 15:09:52 +0200

=== debian/control ===
--- 
+++ 
@@ -29,7 +29,7 @@
                qtdeclarative5-dev-tools,
                xauth,
                xvfb,
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Homepage: https://gitlab.com/ubports/development/apps/lomiri-printing-app/
 Vcs-Git: https://salsa.debian.org/ubports-team/lomiri-printing-app.git
